<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Judul, nomor laporan" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                    <el-button @click="showFilterDialog = true" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-funnel"></i> Filter
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'residentreport', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Laporan
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="residentreports" ref="residentreportTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="No. Laporan"
                width="200">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.number }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Judul"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Kategori"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.category.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Perumahan"
                width="200"
                v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                <template slot-scope="scope">
                    <span>{{ scope.row.residential.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Dibuat Oleh"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.author.profile.fullname }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Status"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.status == 'publish'" type="success" size="mini">Dipublikasikan</el-tag>
                    <el-tag v-else type="info" size="mini">Disimpan</el-tag>
                </template>
            </el-table-column>  
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'residentreport', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'residentreport', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch"/>

        <el-dialog v-loading="filterLoading" title="Filter" :visible.sync="showFilterDialog" width="30%" :show-close="false" @closed="resetForm">
            <aside>
                <el-alert type="info" description="Tampilkan data pemberitahuan berdasarkan kriteria di bawah" :closable=false show-icon></el-alert>
            </aside>
            <el-form ref="filter" :model="filter">
                <el-form-item label="Kata Kunci" prop="keyword">
                    <el-input ref="keyword" name="keyword" v-model="filter.keyword" placeholder="Nama pengguna, no. handphone" autocomplete="off" maxlength="255" clearable></el-input>
                </el-form-item>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Status" prop="status">
                            <el-select v-model="filter.status" placeholder="Pilih status" class="width-100" ref="status" name="status" clearable>
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="filter.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category" clearable>
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :xs="24">
                        <el-form-item label="Pelapor" prop="author" clearable>
                            <el-select 
                                v-model="filter.author" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="author" 
                                name="author"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :xs="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Perumahan" prop="residential">
                            <el-select v-model="filter.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>               
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showFilterDialog = false" size="medium">Batal</el-button>
                <el-button @click="handleSearch" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> Submit
                </el-button>
            </span>
        </el-dialog>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="residentreportForm" :model="residentreportForm" :rules="residentreportRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua laporan warga kepada seluruh pengguna berdasarkan masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Judul" prop="title">
                    <el-input ref="title" name="title" v-model="residentreportForm.title" placeholder="Judul laporan warga" autocomplete="off" min="0" maxlength="255" show-word-limit></el-input>
                </el-form-item>      
                <el-form-item label="Konten" prop="body">
                    <ckeditor :editor="editor" :config="editorConfig" v-model="residentreportForm.body"></ckeditor>
                </el-form-item>          
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :sm="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="Warga Perumahan" prop="residential">
                            <el-select v-model="residentreportForm.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">                                    
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Laporan Dari" prop="author">
                            <el-select 
                                :disabled="residentreportForm.residential == null" 
                                v-model="residentreportForm.author" 
                                placeholder="Ketik nama warga" 
                                class="width-100" 
                                ref="author" 
                                name="author"
                                clearable
                                filterable
                                remote
                                :remote-method="getUsers"
                                value-key="id"
                                >
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id">
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>
                                </el-option>
                            </el-select>
                        </el-form-item>                        
                    </el-col>       
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Kategori" prop="category">
                            <el-select v-model="residentreportForm.category" placeholder="Pilih kategori" class="width-100" ref="category" name="category">
                                <el-option
                                    v-for="item in categories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">
                                </el-option>
                            </el-select>
                        </el-form-item>                        
                    </el-col>
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Status" prop="status">
                            <el-select 
                                v-model="residentreportForm.status" 
                                ref="status" 
                                name="status"
                                placeholder="Pilih perumahan" 
                                class="width-100">
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>                
                <el-form-item label="" prop="showMap">
                    <el-checkbox v-model="showMap">Detil Lokasi</el-checkbox>
                </el-form-item>
                <GmapMap 
                    id="map"
                    v-if="showMap == true" 
                    ref="mapRef"
                    :options="{
                        zoomControl: true,
                        mapTypeControl: false,
                        scaleControl: false,
                        streetViewControl: false,
                        rotateControl: false,
                        fullscreenControl: true,
                        disableDefaultUi: false
                    }"
                    :zoom="map.zoom"
                    :center="map.center">
                    <GmapMarker ref="markerRef" :position="map.center" :draggable="true" @dragend="handleMoveMarker($event)"/>
                </GmapMap>

                <el-form-item label="" prop="medias">
                    <el-upload
                        name="media"
                        :action="uploadURL"
                        with-credentials
                        accept=" .jpg, .jpeg, .png, .doc, .docx, .xls, .xlsx, .pdf"
                        :headers="{'Authorization': 'Bearer ' + token.access_token}"
                        :on-success="handleUploadSuccess"
                        :on-remove="handleUploadRemove"
                        :before-upload="beforeUpload"
                        :file-list="uploadFileList">
                        <el-button size="small" type="primary">Lampiran</el-button>
                        <div slot="tip" class="el-upload__tip">Tipe file: jpg, png, doc/docx, xls/xlsx, pdf</div>
                    </el-upload>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'residentreport', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import {gmapApi} from 'vue2-google-maps';
import ClassicEditor from '@ckeditor/ckeditor5-editor-classic/src/classiceditor';
import EssentialsPlugin from '@ckeditor/ckeditor5-essentials/src/essentials';
import BoldPlugin from '@ckeditor/ckeditor5-basic-styles/src/bold';
import ItalicPlugin from '@ckeditor/ckeditor5-basic-styles/src/italic';
import LinkPlugin from '@ckeditor/ckeditor5-link/src/link';
import ListPlugin from '@ckeditor/ckeditor5-list/src/list';
import ParagraphPlugin from '@ckeditor/ckeditor5-paragraph/src/paragraph';
import AlignmentPlugin from '@ckeditor/ckeditor5-alignment/src/alignment';
import HeadingPlugin from '@ckeditor/ckeditor5-heading/src/heading';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'ResidentReport',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateResidential = (rule, value, callback) => {
            if(['root', 'owner'].indexOf(this.me.role.slug) > -1 && this.residentreportForm.residential == null){
                return callback(new Error('Perumahan wajib dipilih'));
            }
            callback();
        };

        var validateAuthor = (rule, value, callback) => {
            if(this.residentreportForm.residential != null && this.residentreportForm.author == null){
                return callback(new Error('Pelapor wajib dipilih'));
            }
            callback();
        };

        return {
            editor: ClassicEditor,
            editorConfig: {
                plugins: [
                    EssentialsPlugin,
                    BoldPlugin,
                    ItalicPlugin,
                    LinkPlugin,
                    ListPlugin,
                    ParagraphPlugin,
                    AlignmentPlugin,
                    HeadingPlugin
                ],
                toolbar: ['heading', '|', 'bold', 'italic', 'link', 'bulletedList', 'numberedList', 'alignment'],
                alignment: {
                    options: [ 'left', 'center', 'right', 'justify' ]
                },
                heading: {
                    options: [
                        { model: 'paragraph', title: 'Paragraph', class: 'ck-heading_paragraph' },
                        { model: 'heading1', view: 'h1', title: 'Heading 1', class: 'ck-heading_heading1' },
                        { model: 'heading2', view: 'h2', title: 'Heading 2', class: 'ck-heading_heading2' },
                        { model: 'heading3', view: 'h3', title: 'Heading 3', class: 'ck-heading_heading3' }
                    ]
                }
            },
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            showMap: false,
            map: {
                zoom: 14,
                center: {
                    lat: -2.9760735,
                    lng: 104.77543070000002
                }
            },
            status: [{
                label: 'Simpan',
                value: 'draft'
            }, {
                label: 'Publikasikan',
                value: 'publish'
            }],
            filter: {
                keyword: '',
                status: null,
                category: null,
                residential: null,
                author: null                
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Laporan',
                create: 'Tambah Laporan'
            },
            residentreportForm: {
                id: null,
                title: null,
                status: 'draft',
                category: null,
                author: null,
                residential: null,
                latitude: null,
                longitude: null,
                archived: false,
                medias: []
            },
            residentreportRules: {
                title: [{ 
                    required: true, message: 'Judul laporan wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang Judul laporan maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                status: [{
                    required: true, message: 'Status pemberitahuan wajib diisi', trigger: 'change'
                }],
                category: [{
                    required: true, message: 'Kategori laporan wajib diisi', trigger: 'change'
                }],
                residential: [{
                    validator: validateResidential, trigger: 'change'
                }],
                author: [{
                    validator: validateAuthor, trigger: 'change'
                }],
                content: [{ required: true, message: 'Konten laporan wajib diisi', trigger: 'blur'}]
            },
            uploadFileList: [],
            uploadURL: ''
        };
    },
    computed: {
        tableHeight,
        google: gmapApi,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('category', ['categories']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('residentreport', [
            'residentreports',
            'pagination'
        ]),
    },
    created() {
        this.getResidentReports();
        this.getCategories();
        this.getResidentials();        
    },
    methods: {
        playSound,
        dateFormat,
        getResidentReports() {
            this.tableLoading = true;
            this.$store.dispatch('residentreport/getResidentReports', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getCategories() {
            this.tableLoading = true;
            this.$store.dispatch('category/getCategories', {
                module: 'residentreport',
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;                
            });
        },
        getUsers(q) {
            if(q.trim().length >= 3){
                this.tableLoading = true;
                this.$store.dispatch('user/getUsers', {
                    q: q,
                    residential: this.residentreportForm.residential,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.tableLoading = false;                
                });
            }
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.status != null){
                payload['status'] = this.filter.status;
            }

            if(this.filter.author != null){
                payload['author'] = this.filter.author;
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            if(this.filter.category != null){
                payload['category'] = this.filter.category;
            }

            this.tableLoading = true;
            this.$store.dispatch('residentreport/getResidentReports', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleResidentialChange(){
            this.getUsers();
        },
        handleMoveMarker(e){
            this.residentreportForm.latitude = e.latLng.lat();
            this.residentreportForm.longitude = e.latLng.lng();

            var self = this;

            setTimeout(() => {
                self.$refs.mapRef.$mapPromise.then((map) => {
                    map.setZoom(18);
                    map.panTo({lat: e.latLng.lat(), lng: e.latLng.lng()});
                });
            }, 100);
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.uploadURL = 'http://api.ringsatu.id/v1/media/tmp';
            this.$nextTick(() => {
                this.$refs['residentreportForm'].clearValidate();
            });
        },
        handleEdit(residentreport){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.uploadURL = 'http://api.ringsatu.id/v1/media/residentreport/'+residentreport.id
            this.residentreportForm.id = residentreport.id;
            this.residentreportForm.title = residentreport.title;
            this.residentreportForm.body = residentreport.body;
            this.residentreportForm.latitude = residentreport.latitude;
            this.residentreportForm.longitude = residentreport.longitude;
            this.residentreportForm.status = residentreport.status;
            this.residentreportForm.category = residentreport.category.id;
            this.residentreportForm.author = residentreport.author.id; 
            this.residentreportForm.residential = residentreport.residential.id; 
            this.residentreportForm.archived = residentreport.archived;

            if(residentreport.medias != null){
                for(const i of residentreport.medias){
                    this.residentreportForm.medias.push(i.id);
                    this.uploadFileList.push({
                        id: i.id,
                        name: i.original_filename
                    });
                }
            }else{
                this.residentreportForm.medias = residentreport.medias;
            }

            this.getUsers(residentreport.author.profile.fullname);

            if(residentreport.latitude && residentreport.longitude){
                this.showMap = true;
                this.map.center.lat = residentreport.latitude;
                this.map.center.lng = residentreport.longitude;

                var self = this;

                setTimeout(() => {
                    self.$refs.mapRef.$mapPromise.then((map) => {
                        map.setZoom(18);
                        map.panTo(self.map.center);
                    });
                }, 100);
            }

            this.$nextTick(() => {
                this.$refs['residentreportForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.residentreportForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'residentreport/addResidentReport';
                        payload = {
                            title: this.residentreportForm.title,
                            body: this.residentreportForm.body,
                            latitude: this.residentreportForm.latitude,
                            longitude: this.residentreportForm.longitude,
                            status: this.residentreportForm.status,
                            category: this.residentreportForm.category,
                            author: this.residentreportForm.author,
                            residential: this.residentreportForm.residential,
                            medias: this.residentreportForm.medias
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'residentreport/editResidentReport';
                        payload = {
                            id: this.residentreportForm.id,
                            title: this.residentreportForm.title,
                            body: this.residentreportForm.body,
                            latitude: this.residentreportForm.latitude,
                            longitude: this.residentreportForm.longitude,
                            status: this.residentreportForm.status,
                            category: this.residentreportForm.category,
                            author: this.residentreportForm.author,
                            residential: this.residentreportForm.residential,
                            medias: this.residentreportForm.medias,
                            archived: this.residentreportForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(residentreport){
            this.$confirm('Anda mencoba untuk menghapus data laporan warga, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('residentreport/deleteResidentReport', {
                    id: residentreport.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.residentreportForm = {
                id: null,
                title: null,
                status: 'draft',
                category: null,
                author: null,
                residential: null,
                archived: false,
                medias: []
            }

            this.uploadFileList = [];
        },
        beforeUpload(file) {
            if (['image/jpeg', 'image/png', 'application/pdf', 'application/msword', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.ms-excel', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/wps-office.docx', 'application/wps-office.doc', 'application/wps-office.xlsx', 'application/wps-office.xls',].indexOf(file.type) < 0) {
                this.$message.error('Hanya image dengan tipe file jpg, png, doc/docx, xls/xlsx dan pdf yang diperbolehkan.');
                return false;
            }
            if (file.size > (8 * 1024 * 1024)) {
                this.$message.error('Ukuran file tidak boleh lebih dari 8MB.');
                return false;
            }
            return true;
        },
        handleUploadSuccess(res) {
            this.residentreportForm.medias.push(res.data.media.id);
            this.uploadFileList.push({
                name: res.data.media.original_filename,
                id: res.data.media.id
            });
        },
        handleUploadRemove(file){
            for(const i of this.uploadFileList){
                if(i.id === file.id){
                    this.uploadFileList.splice(i, 1);
                    break;
                }
            }

            let action = '';
            let params = {};

            if(this.dialogStatus == 'create'){
                action = 'media/deleteMediaTmp';
                params.id = file.id;
            }else{
                action = 'media/deleteMedia';
                params.id = file.id;
                params.endpoint = 'residentreport';
            }

            this.$store.dispatch(action, params).then((response) => {
                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    this.$message.success({
                        message: response.message
                    });
                }

                this.playSound();
            });
        },
    }

}
</script>
<style>
    #map{
        width: 100%;
        height: 400px;
    }
</style>